#include <windows.h>
#include "app.hpp"

#pragma hdrstop

#include "window.hpp"
#include "handler.hpp"
#include "paint.hpp"
#include "rect.hpp"

////////////////////////////////////////////////////////////
// class AppWin (interface)
////////////////////////////////////////////////////////////
class AppWin : public Window
{
    static Handler aHandler;
public:
    Handler *getHandler(void) { return &aHandler; }
    long wmPaint(UINT, WPARAM, LPARAM);
    long idm101(UINT, WPARAM, LPARAM);
    long idm102(UINT, WPARAM, LPARAM);
    long idm103(UINT, WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////
// class AppWin (implementation)
////////////////////////////////////////////////////////////
long AppWin::idm101(UINT, WPARAM, LPARAM)
{
    MessageBox(hwnd(),
               "Choice 1 selected",
               "Message Box Title: Menu1",
               MB_OK);
    return 0L;
}

long AppWin::idm102(UINT, WPARAM, LPARAM)
{
    MessageBox(hwnd(),
               "Choice 2 selected",
               "Message Box Title: Menu1",
               MB_OKCANCEL | MB_ICONEXCLAMATION);
    return 0L;
}

long AppWin::idm103(UINT, WPARAM, LPARAM)
{
    MessageBox(hwnd(),
               "Choice 3 selected",
               "Message Box Title: Menu1",
               MB_YESNOCANCEL | MB_ICONQUESTION);
    return 0L;
}
long AppWin::wmPaint(UINT, WPARAM, LPARAM)
//long AppWin::wmPaint(WORD, WORD, LONG)
{
    Paint p(hwnd());    // Construct paint object (derived from PAINTSTRUCT)

    // Draw the text in the middle of the window's client area
    Rect aRect;
    aRect.getClient(hwnd());
    DrawText(p, "Hello, world", -1, &aRect,
        DT_SINGLELINE | DT_CENTER | DT_VCENTER);
    return 0L;
}

////////////////////////////////////////////////////////////
// class AppWin (callbacks)
////////////////////////////////////////////////////////////
static CB MsgCBT[] = {
    { WM_PAINT, (CBPROC) AppWin::wmPaint },
    { 0,        NULL }
};

static CB CmdCBT[] = {
    { 101, (CBPROC) AppWin::idm101 },
    { 102, (CBPROC) AppWin::idm102 },
    { 103, (CBPROC) AppWin::idm103 },
    { 0,   NULL }
};

Handler AppWin::aHandler(MsgCBT, CmdCBT);

////////////////////////////////////////////////////////////
// WinMain
////////////////////////////////////////////////////////////
int PASCAL WinMain(HANDLE hInstance,
                   HANDLE hPrevInstance, LPSTR, int)
{
    AppWin aWindow;
    aWindow.setCaption("Paint: WindowFrame Example Program");
    aWindow.setMenuName(100);

    App anApp(hInstance, hPrevInstance);
    return anApp.run(aWindow, "Paint");
}

