#include <windows.h>
#include "app.hpp"

#pragma hdrstop

#include "window.hpp"
#include "handler.hpp"
#include "paint.hpp"
#include "rect.hpp"

////////////////////////////////////////////////////////////
// class AppWin
////////////////////////////////////////////////////////////
class AppWin : public Window
{
    static Handler aHandler;
public:
    Handler *getHandler(void) { return &aHandler; }
    long wmPaint(UINT, WPARAM, LPARAM);
};

static CB MsgCbList[] = {
    { WM_PAINT, (CBPROC) AppWin::wmPaint },
    { 0,        NULL }
};

long AppWin::wmPaint(UINT, WPARAM, LPARAM)
{
    Paint p(hwnd());    // Construct paint object (derived from PAINTSTRUCT)

    // Draw the text in the middle of the window's client area
    Rect aRect;
    aRect.getClient(hwnd());
    DrawText(p, "Hello, world", -1, &aRect,
        DT_SINGLELINE | DT_CENTER | DT_VCENTER);
    return 0L;
}


Handler AppWin::aHandler(MsgCbList);

////////////////////////////////////////////////////////////
// WinMain
////////////////////////////////////////////////////////////
int PASCAL WinMain(HANDLE hInstance,
                   HANDLE hPrevInstance, LPSTR, int)
{
    AppWin aWindow;
    aWindow.setCaption("Paint: WindowFrame Example Program");
    aWindow.setMenuName(100);

    App anApp(hInstance, hPrevInstance);
    return anApp.run(aWindow, "Paint");
}

