//
// DLGTST.CPP   Window Frame Dialog Box Test program.
//
// Created:     Bruce Clift  7/31/91
//

#include <windows.h>

#include "app.hpp"
#include "message.hpp"

#include "dtmain.hpp"


///////////////////////////////////
// DERIVED CLASS FOR APPLICATION //
///////////////////////////////////

class AppDlgTst : public App {
public:
    // Default constructor
    AppDlgTst(HINSTANCE hi, HINSTANCE hpi) : App(hi, hpi) {}

    // Redefine the message loop for modeless dialog box
    WORD messageLoop(void) {
        Message msg;
        return msg.loop(((WinDlgTst *) pMain) ->getModeless());
    }

};

//
// The WinMain entry procedure simply creates the derived application object,
// passing its parameters to the constructor, and the runs the application.
//
int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR, int)
{
    WinDlgTst aWindow;
    aWindow.setCaption("Dialog Test Program");
    aWindow.setMenuName(ID_DTMENU);

    AppDlgTst anApp(hInstance, hPrevInstance);
    return anApp.run(aWindow, "DlgTst");
}
