//
// DTMAIN.HPP   Main window class interface for dialog test program.
//
// Created:     Bruce Clift  8/15/91
//

#ifndef __DTMAIN_HPP
#define __DTMAIN_HPP

#include "window.hpp"
#include "handler.hpp"
#include "modeless.hpp"
#include "statusba.hpp"

#include "dtres.h"


///////////////////////////////////
// DERIVED CLASS FOR MAIN WINDOW //
///////////////////////////////////

class WinDlgTst : public Window {
private:
    static Handler aHandler;    // Use Handler object for messages
    Modeless modelessDlg;       // Modeless dialog object
    StatusBar aStatusBar;       // Status bar at bottom of window
    int iHelp;                  // Help index value

public:
    // Default constructor clears instance variables
    WinDlgTst() : iHelp(0) {}

    // Data member access
    Handler *getHandler(void)       { return &aHandler; }
    Modeless *getModeless(void)     { return &modelessDlg; }
    StatusBar *getStatusBar(void)   { return &aStatusBar; }

    // Initialize the status bar
    BOOL setChildren(void) { aStatusBar.set(this); return TRUE; }

    // Methods to provide status bar help
    int getHelpIndex(void);
    int getMenuHelpIndex(int i)  { return (IDS_MENUID + i); }
    int getPopupHelpIndex(int i) { return (IDS_POPUPID + i); }

    // Callback methods
    LRESULT wmInitMenu(UINT, WPARAM, LPARAM);

    LRESULT idmModeless(UINT, WPARAM, LPARAM);
    LRESULT idmAbout(UINT, WPARAM, LPARAM);

};

#endif // __DTMAIN_H
