#
# DEFS.MAK   Include file for WindowFrame makefiles.
#
# Created:  Bruce Clift  9/17/91
#

DEBUG=1

.autodepend
.swap


############################################################
## Define a compiler version
##
##  Be sure that ONLY ONE of the
##  compilers listed below is defined
##  by removing the comment (#) character
##  in the first column.
############################################################
#BC20=1
#BC30=1
BC31=1

############################################################
## Directory paths
##
##  Edit the following two path specifications to
##  reflect the location of the compiler and
##  the directory in which WindowFrame has been
##  installed.
##
############################################################
CCDIR=c:\borlandc
WFDIR=c:\wf

############################################################



HDIR=$(WFDIR)\include
LDIR=$(WFDIR)\lib
H=$(HDIR)\\
L=$(LDIR)\\


############################################################
## Compiler/linker options
############################################################
!if !$d(MODEL)
MODEL=s
!endif

!if $d(DEBUG)
CCDBG=-v
LNKDBG=/v
!else
CCDBG=
LNKDBG=
!endif

CC=bcc
CCWIN=-W
CCOPTS=-c -I$(HDIR);$(CCDIR)\include -m$(MODEL) $(CCDBG) -vi $(CCWIN)

LNK=tlink
LNKWIN=/Tw
LNKOPTS=$(LNKWIN)$(LNKDBG)/c/L$(CCDIR)\lib c0w$(MODEL)


!if $d(BC20)
CWINL=cwin
!elif $d(BC30)
CWINL=cw
!elif $d(BC31)
CWINL=cw
!else
!error Compiler version not defined.  Define one of (BC20 BC30 BC31)
!endif

WFLIBS =$(L)wf$(MODEL) import $(CWINL)$(MODEL) c$(MODEL)
#WFMLIBS =$(L)wf$(MODEL) import $(CWINL)$(MODEL) math$(MODEL) c$(MODEL)
WFMLIBS =$(L)wf$(MODEL) import $(CWINL)$(MODEL) mathw$(MODEL) c$(MODEL)
WFDEF  =$(L)wf.def

LIB=tlib
LIBOPTS=/C


#
# Rules
#
.cpp.obj :
    $(CC) $(CCOPTS) {$& }
.rc.res :
    rc -r -I$(HDIR);$(CCDIR)\include $<


