#
# DEFS_MSC.MAK   Include file for WindowFrame makefiles.
#
# Created:  Greg Voss   5/10/93
# Modified: Greg Voss   11/16/93
#

DEBUG=1


############################################################
## DEFAULTS makefile for Microsoft C/C++ 7.0
##
## Assumes WindowFrame is installed in \wf directory.
## Edit pathnames below if this is not the case.
############################################################

############################################################
## Define a compiler version
##
## Be sure that only MSCxx variables are set
## for this makefile.
############################################################
MSC=1
MSC70=1

############################################################
## Directory paths
##
##  Edit the following two path specifications to
##  reflect the location of the compiler and
##  the directory in which WindowFrame has been
##  installed.
##
############################################################
CCDIR=C:\c700
WFDIR=C:\wf

############################################################



HDIR=$(WFDIR)\include
LDIR=$(WFDIR)\lib
H=$(HDIR)\\
L=$(LDIR)\\


############################################################
## Compiler/linker options
############################################################
!ifdef MODEL
MODEL=S         # small memory model
!endif

!ifdef DEBUG
CCDBG=/Od /Zi
LNKDBG=/CO
!else
CCDBG=
LNKDBG=
!endif

CC=CL
CCWIN= /Gsw    
# /Gs - no stack checking
# /Gw - Generate Entry/Exit Code for Real-Mode Windows functions (p.522)
CCOPTS= /c /I$(HDIR) /I$(CCDIR)\include /A$(MODEL) $(CCDBG) /W2 $(CCWIN)

LNK=link
LNKWIN=/Tw
LNKOPTS=$(LNKDBG) /NOD
######################################################################
## Meaning of CFLAGS for MSC 7.0 Compiler
## /AS      small memory model
## /Gs      turn off run-time stack checking
## /Od      turn off all optimizations (use with /Zi for debugging)
## /Zi      include symbolic debug information in obj files
## /Ipath   dir indicates additional path to search for #include 
## /Wn      set warning level to n
######################################################################

######################################################################
## Meaning of LFLAGS for MSC 7.0 Linker
## /CO      include symbolic debug information in exe files
######################################################################


##!if $d(BC20)
##CWINL=cwin
##!elif $d(BC30)
##CWINL=cw
##!elif $d(BC31)
##CWINL=cw
##!else
##!error Compiler version not defined.  Define one of (BC20 BC30 BC31)
##!endif
WFLIBS=$(L)wf$(MODEL)
##  WFLIBS =$(L)wf$(MODEL) import $(CWINL)$(MODEL) c$(MODEL)
##  #WFMLIBS =$(L)wf$(MODEL) import $(CWINL)$(MODEL) math$(MODEL) c$(MODEL)
##  WFMLIBS =$(L)wf$(MODEL) import $(CWINL)$(MODEL) mathw$(MODEL) c$(MODEL)
##  WFDEF  =$(L)wf.def

LIB=lib
LIBOPTS=


#
# Rules
#
.cpp.obj :
    $(CC) $(CCOPTS) $<
.rc.res :
    rc -r -I$(HDIR);$(CCDIR)\include $<


