//
// ACCELERA.HPP Interface for Accelerator class.
//
// Created:     Bruce Clift  8/22/91
//

#ifndef __ACCELERA_HPP
#define __ACCELERA_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Accelerator {
private:
    HACCEL  _haccel;        // Accelerator table handle

public:
    // Default constructor clears the handle
    Accelerator() : _haccel(NULL) {}

    // The load constructor and method load an accelerator table resource
    Accelerator(HINSTANCE hInst, LPCSTR lpName) : _haccel(NULL)
        { load(hInst, lpName); }
    HACCEL load(HINSTANCE hInst, LPCSTR lpName)
        { return (_haccel = LoadAccelerators(hInst, lpName)); }

    // The destructor and destroy method just reset the handle
    ~Accelerator(void) { destroy(); }
    BOOL destroy(void) { _haccel=NULL; return TRUE;}

    // Data member access
    HACCEL haccel(void)         { return (_haccel); }
    HACCEL haccel(HACCEL ha)    { return (_haccel = ha); }

    // Operator methods
    BOOL operator! (void) { return (_haccel == NULL); }
    operator HACCEL (void) { return (_haccel); }

    // Windows convenience methods
    int     translate(HWND hw, LPMSG lpMsg)
        { return TranslateAccelerator(hw, _haccel, lpMsg); }

};  // Accelerator

#endif // __ACCELERA_HPP
