//
// APP.HPP      Class interface and inline member implementation for App.
//
// Created:     Bruce Clift  6/24/91
//

#ifndef __APP_HPP
#define __APP_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __WINDOW_HPP
#include "window.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class App {
protected:
    // WinMain parameters
    HINSTANCE   hInstance;          // Handle to current instance
    HINSTANCE   hPrevInstance;      // Handle to previous instance
    LPSTR       lpCmdLine;          // Command line
    int         nCmdShow;           // How to display Main Window

    Window      *pMain;             // Pointer to main window
    char        *szName;            // Application name

public:
    // Usual constructor sets WinMain parameters and clears pointers
    App(HINSTANCE hi, HINSTANCE hpi=NULL,
        LPSTR cl=NULL, int cs=SW_SHOWNORMAL);

    // Application execution method
    virtual WORD run(void);
    virtual WORD run(Window &pMainWindow, char *szAppName=NULL);

    // Initialization methods
    virtual BOOL initApp(void);
    virtual BOOL initAnother(void);
    virtual BOOL initInst(void);

    // Run the message loop
    virtual WORD messageLoop(void);

};  // App


///////////////////////
// WinMain PROTOTYPE //
///////////////////////

extern "C" int PASCAL WinMain(HINSTANCE, HINSTANCE, LPSTR, int);

#endif // __APP_HPP
