//
// COMBOBOX.HPP Interface for ComboBox, derived from Window.
//
// Created:     Bruce Clift  8/26/91
//

#ifndef __COMBOBOX_HPP
#define __COMBOBOX_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __CONTROL_HPP
#include "control.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class ComboBox : public Control {
public:
    // Constructors and destructors
    ComboBox() : Control() {}
    ComboBox(HWND hd, int id) : Control(hd, id) {}

    // Creation method alterations
    LPCSTR getClassName(void) { return "combobox"; }

    // Message functions
    int     addString(LPCSTR lpsz)
        { return SendMessage(hwnd(), CB_ADDSTRING, 0, (LONG) lpsz); }
    int     deleteString(int nIndex)
        { return SendMessage(hwnd(), CB_DELETESTRING, nIndex, 0L); }
    int     dir(WORD wAttribute, LPCSTR lpFileSpec)
        { return 1+SendMessage(hwnd(), CB_DIR, wAttribute, (LONG) lpFileSpec); }
    int     findString(int nIndex, LPCSTR lpPrefix)
        { return SendMessage(hwnd(), CB_FINDSTRING, nIndex, (LONG) lpPrefix); }
    int     getCount(void)
        { return SendMessage(hwnd(), CB_GETCOUNT, 0, 0L); }
    int     getCurSel(void)
        { return SendMessage(hwnd(), CB_GETCURSEL, 0, 0L); }
    void    getEditSel(int &nFirst, int &nLast)
        { long l=SendMessage(hwnd(), CB_GETEDITSEL, 0, 0L);
            nFirst=LOWORD(l); nLast=HIWORD(l); }
    LONG    getItemData(int nIndex)
        { return SendMessage(hwnd(), CB_GETITEMDATA, nIndex, 0L); }
    int     getLBText(int nIndex, LPSTR lpsz)
        { return SendMessage(hwnd(), CB_GETLBTEXT, nIndex, (LONG) lpsz); }
    int     getLBTextLen(int nIndex)
        { return SendMessage(hwnd(), CB_GETLBTEXTLEN, nIndex, 0L); }
    int     insertString(int nIndex, LPCSTR lpsz)
        { return SendMessage(hwnd(), CB_INSERTSTRING, nIndex, (LONG) lpsz); }
    void    limitText(int nMax)
        { SendMessage(hwnd(), CB_LIMITTEXT, nMax, 0L); }
    int     resetContent(void)
        { return SendMessage(hwnd(), CB_RESETCONTENT, 0, 0L); }
    int     selectString(int nIndex, LPCSTR lpPrefix)
        { return SendMessage(hwnd(), CB_SELECTSTRING, nIndex, (LONG)lpPrefix); }
    int     setCurSel(int nIndex)
        { return SendMessage(hwnd(), CB_SETCURSEL, nIndex, 0L); }
    void    setEditSel(int nFirst, int nLast)
        { SendMessage(hwnd(), CB_SETEDITSEL, 0, MAKELONG(nFirst, nLast)); }
    int     setItemData(int nIndex, LONG lData)
        { return SendMessage(hwnd(), CB_SETITEMDATA, nIndex, lData); }
    void    showDropDown(BOOL bShow)
        { SendMessage(hwnd(), CB_SHOWDROPDOWN, bShow, 0L); }

};

#endif // __COMBOBOX_HPP
