//
// FILE.HPP     Windows file handling support.
//
// Created:     Bruce Clift  11/22/91
//

#ifndef __FILE_HPP
#define __FILE_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class File : public OFSTRUCT {
protected:
    int     hFile;              // Handle to open file
    WORD    _wFlags;

public:
    // Constructors and destructors
    File();
    ~File() { close(); }

    // Standard file operations
    virtual BOOL open(LPCSTR szPath, UINT wFlags = OF_READ);
    virtual BOOL close(void);

    virtual BOOL reopen(void);
    virtual BOOL reopen(UINT wFlags);
    virtual long seek(long lOffset, int iOrigin = 0);
    virtual UINT read(HPVOID lpBuffer, UINT wBytes);
    virtual UINT write(HPCVOID lpBuffer, UINT wBytes);

    // Other useful operations
    char *getPath(void) { return ((char *) szPathName); }
    long length(void);
    long position(void) { return (seek(0L, 1)); }
    int  unlink(void);


    // Status reporting
    BOOL ok(void)           { return (nErrCode == 0); }
    operator BOOL (void)    { return (nErrCode == 0); }
    BOOL operator! (void)   { return (nErrCode != 0); }

};

#endif // __FILE_HPP
