//
// FILEDLG.HPP  Interface for File menu dialog box classes.
//
// Created:     Bruce Clift  8/22/92
//

#ifndef __FILEDLG_HPP
#define __FILEDLG_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __MODAL_HPP
#include "modal.hpp"
#endif

class File;


//////////////////////////////////////////
// BASE CLASS FOR OPEN AND SAVE DIALOGS //
//////////////////////////////////////////

class FileDialog : public Modal {
protected:
    File *pFile;

    char szDefExt   [5];
    char szFileName [96];
    char szFileSpec [16];
    WORD wFileAttr;

public:
    FileDialog(File *pF, char *szExt, char *szSpec, WORD wAttr);

    // Data member access
    char *getFileName(void) { return szFileName; }

    int updateLBs(LPSTR szName);

    // Standard file open dialog box callback methods
    LRESULT wmInitDialog(UINT, WPARAM, LPARAM);
    LRESULT idcFname(UINT, WPARAM, LPARAM);
    LRESULT idcList(UINT, WPARAM, LPARAM);
    void regDefMsgs(Handler *pHand);

};


//////////////////////
// FILE OPEN DIALOG //
//////////////////////

class FileOpenDialog : public FileDialog {
public:
    FileOpenDialog(File *pF, char *szExt, char *szSpec, WORD wAttr);

    // Standard file open dialog box callback methods
    LRESULT idOk(UINT, WPARAM, LPARAM);
    void regDefMsgs(Handler *pHand);

};


//////////////////////
// FILE SAVE DIALOG //
//////////////////////

class FileSaveDialog : public FileDialog {
private:
    WORD wStatus;

public:
    FileSaveDialog(File *pF, char *szExt, char *szSpec);

    // Data member access
    WORD getStatus(void) { return wStatus; }

    // Standard file save dialog box callback methods
    LRESULT idOk(UINT, WPARAM, LPARAM);
    void regDefMsgs(Handler *pHand);

};


//
// Utility functions
//
LPSTR lstrchr (LPSTR str, char ch);
LPSTR lstrrchr(LPSTR str, char ch);


#endif // __FILEDLG_HPP
