//
// LIST.HPP     General purpose list with fast binary searching.
//
// Created:     Bruce Clift  8/20/91
//

#ifndef __LIST_HPP
#define __LIST_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif


//////////////////////////
// LIST TYPE DEFINITION //
//////////////////////////

typedef struct tagITEM {    // Every list item contains:
    WORD    wIndex;         // an index search key
    DWORD   dwData;         // and four bytes of data.
} ITEM;

typedef ITEM        *PITEM;
typedef ITEM NEAR   *NPITEM;
typedef ITEM FAR    *LPITEM;


/////////////////////
// CLASS INTERFACE //
/////////////////////

class List {
private:
    NPITEM  pItem;          // Pointer to sorted list of items
    int     cItems;         // Number of items in list

public:
    // The default constructor simply clears the instance variables
    List();

    // The destructor and destroy method free the list and reset the count
    ~List() { destroy(); }
    void    destroy(void);

    // Overloaded operators
    BOOL operator! (void) { return (cItems == 0); }
    operator int (void) { return (cItems); }

    // List management
    BOOL    insert(WORD wIndex, DWORD dwData, BOOL bDestructive=TRUE);
    BOOL    remove(WORD wIndex);
    DWORD   item(WORD wIndex);

private:
    // Get index of item in list
    DWORD NEAR find(WORD wIndex);

};  // List

#endif // __LIST_HPP
