//
// MESSAGE.HPP  Interface for message class, derived from Windows MSG struct.
//
// Created:     Bruce Clift  6/24/91
//

#ifndef __MESSAGE_HPP
#define __MESSAGE_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

class Modeless;
class Window;


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Message : public MSG {
public:
    // Overloaded operator returns the message value
    operator UINT (void) { return (message); }

    // General message methods
    BOOL get(HWND hw=NULL, UINT wMin=0, UINT wMax=0)
            { return GetMessage(this, hw, wMin, wMax); }
    BOOL peek(HWND hw=NULL, UINT wMin=0, UINT wMax=0, UINT wRmv=PM_REMOVE)
            { return PeekMessage(this, hw, wMin, wMax, wRmv); }
    LONG dispatch(void)
            { return DispatchMessage(this); }
    BOOL isDialog(HWND hDlg)
            { return (hDlg && IsDialogMessage(hDlg, this)); }

    // Translation methods
    BOOL translate(void)
            { return TranslateMessage(this); }
    int accelerator(HWND hwMain, HACCEL hAccel)
            { return TranslateAccelerator(hwMain, hAccel, this); }
    BOOL mdiSysAccel(HWND hwClient)
            { return TranslateMDISysAccel(hwClient, this); }

    // Message loop methods
    WPARAM loop(void);
    WPARAM loop(Modeless *pMdls);
    WPARAM loop(Window *pMain);
    WPARAM loop(Window *pMain, Modeless *pMdls);
    WPARAM loop(HWND hwClient);
    WPARAM loop(HWND hwClient, Modeless *pMdls);
    WPARAM loop(HWND hwClient, Window *pMain);
    WPARAM loop(HWND hwClient, Window *pMain, Modeless *pMdls);

};  // Message

#endif // __MESSAGE_HPP
