//
// MODAL.HPP    Interface for Modal dialog box class.
//
// Created:     Bruce Clift  10/28/91
//

#ifndef __MODAL_HPP
#define __MODAL_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __DIALOG_HPP
#include "dialog.hpp"
#endif

class Handler;


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Modal : public Dialog {
public:
    // Default constructor just calls Dialog constructor
    Modal();

    // Methods to run a modal dialog box
    // (assume parent window's instance handle if none given)
    int run(LPCSTR lpszTmplt, HWND hwPar, LPARAM lParam=0L)
        { return run(GetWindowWord(hwPar, GWW_HINSTANCE),
            lpszTmplt, hwPar, lParam); }
    int run(HINSTANCE hInst, LPCSTR lpszTmplt, HWND hwPar, LPARAM lParam=0L);

    // Standard modal dialog box callback methods
    LRESULT wmInitDialog(UINT, WPARAM, LPARAM);
    LRESULT idOk(UINT, WPARAM, LPARAM);
    LRESULT idCancel(UINT, WPARAM, LPARAM);
    void regDefMsgs(Handler *pHand);

};

#endif // __MODAL_HPP

