//
// MODELESS.HPP Interface for Modeless dialog boxes.
//
// Created:     Bruce Clift  10/28/91
//

#ifndef __MODELESS_HPP
#define __MODELESS_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __DIALOG_HPP
#include "dialog.hpp"
#endif

class Handler;


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Modeless : public Dialog {
public:
    // Default constructor just calls Dialog constructor
    Modeless();

#pragma warn -hid
    // Routines to create a modeless dialog box
    // (assume parent window's instance handle if none given)
    HWND create(LPCSTR lpszTmplt, HWND hwPar, LPARAM lParam=0L)
        { return create(GetWindowWord(hwPar, GWW_HINSTANCE),
            lpszTmplt, hwPar, lParam); }
    HWND create(HINSTANCE hInst, LPCSTR lpszTmplt, HWND hwPar, LPARAM lParam=0L);
#pragma warn .hid

    // By default, create a visible dialog box  (even if WS_VISIBLE is
    // not specified in the template's STYLE line).
    virtual BOOL createVisible(void);

    // Standard modeless dialog box callback methods
    void regDefMsgs(Handler *pHand);
    LRESULT idOk(UINT, WPARAM, LPARAM);
    LRESULT idCancel(UINT, WPARAM, LPARAM);

};

#endif // __MODELESS_HPP

