//
// OWNERDRA.HPP Interface for OwnerDrawButton, derived from PushButton.
//
// Created:     Bruce Clift  8/26/91
//

#ifndef __OWNERDRA_HPP
#define __OWNERDRA_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __PUSHBUTT_HPP
#include "pushbutt.hpp"
#endif

class Bitmap;


/////////////////////
// CLASS INTERFACE //
/////////////////////

class OwnerDrawButton : public PushButton {
protected:
    Bitmap *pBitmap1, *pBitmap2;

public:
    // Constructors
    OwnerDrawButton()
        : PushButton(), pBitmap1(NULL), pBitmap2(NULL)
        {}
    OwnerDrawButton(Bitmap *pBmp1, Bitmap *pBmp2 = NULL)
        : PushButton(), pBitmap1(pBmp1), pBitmap2(pBmp2)
        {}
    OwnerDrawButton(HWND hd, int id)
        : PushButton(hd, id), pBitmap1(NULL), pBitmap2(NULL)
        {}

    // Setting the bitmaps
    void setBitmap(Bitmap *pBmp1)
        { pBitmap1 = pBmp1; }
    void setBitmaps(Bitmap *pBmp1, Bitmap *pBmp2)
        { pBitmap1 = pBmp1; pBitmap2 = pBmp2; }
    Bitmap *getBitmap1(void) { return pBitmap1; }
    Bitmap *getBitmap2(void) { return pBitmap2; }

    // Creation method alterations
    long addStyle(long l)
        { return (BS_OWNERDRAW | PushButton::addStyle(l)); }

    // Hooks for derived classes to draw themselves
    virtual void drawItem   (LPDRAWITEMSTRUCT lpDIS);
    virtual void focus      (LPDRAWITEMSTRUCT lpDIS);
    virtual void select     (LPDRAWITEMSTRUCT lpDIS);
    virtual void drawEntire (LPDRAWITEMSTRUCT lpDIS);

protected:
    void drawBitmap(LPDRAWITEMSTRUCT lpDIS, Bitmap *pBmp);

};

#endif // __OWNERDRA_HPP

