//
// PAINT.HPP    Interface for Paint class, derived from Windows' PAINTSTRUCT.
//
// Created:     Bruce Clift  8/23/91
//

#ifndef __PAINT_HPP
#define __PAINT_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Paint : public PAINTSTRUCT {
private:
    HWND    _hw;            // Window handle being painted

public:
    // The only available constructor calls the BeginPaint API function
    Paint(HWND hw) { begin(hw); }
    ~Paint() { end(); }

    // begin and end methods
    HDC     begin(HWND hw)  { return BeginPaint(_hw=hw, this); }
    void    end()           { if (hdc) EndPaint(_hw, this); hdc=NULL; }
    void    destroy()       { end(); }

    // Data member access
    HWND    hwnd(void) { return _hw; }
    HWND    hwnd(HWND hw) { return (_hw = hw); }

    // Overloaded ops test the value of PAINTSTRUCT's device context handle
    BOOL operator! (void) { return (hdc == NULL); }
    operator HDC (void) { return (hdc); }

};  // Paint

#endif // __PAINT_HPP
