//
// PEN.HPP      Interface for Pen, derived from LOGPEN struct.
//
// Created:     Bruce Clift  8/19/91
//

#ifndef __PEN_HPP
#define __PEN_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Pen : public LOGPEN {
private:
    HPEN    _hpen;          // Pen handle
    BOOL    bStock;         // Is pen a stock object?

public:
    // Default constructor clears the handle and LOGPEN structure
    Pen();
    // The no-parameter create expects the user to fill the LOGPEN fields
    HPEN create(void)
        { bStock=FALSE; return (_hpen=CreatePenIndirect(this)); }

    // The other create constructor and method manually create a pen
    Pen(int nPenStyle, int nWidth, COLORREF crColor)
        { create(nPenStyle, nWidth, crColor); }
    HPEN create(int nPenStyle, int nWidth, COLORREF crColor) {
        lopnStyle = nPenStyle;
        lopnWidth.x = nWidth;
        lopnColor = crColor;
        return create();
    }

    // Get stock constructor and method get a stock pen
    Pen(int nIndex) { getStock(nIndex); }
    HPEN getStock(int nIndex);

    // The destructor and destroy method destroy pens that were created
    ~Pen() { destroy(); }
    BOOL destroy(void);

    // Data member access
    HPEN hpen(void)     { return (_hpen); }
    HPEN hpen(HPEN hp)  { return (_hpen = hp); }

    // Operator methods
    BOOL operator! (void) { return (_hpen == NULL); }
    operator HPEN (void) { return (_hpen); }

    // Windows convenience methods
    HPEN    select(HDC hdc) { return SelectObject(hdc, _hpen); }
    int     get(void)
        { return GetObject(_hpen, sizeof(LOGPEN),
            (LPSTR)(LOGPEN *) this); }

};  // Pen

#endif // __PEN_HPP
