//
// POPUP.HPP    Interface for PopupMenu class, derived from Menu.
//
// Created:     Bruce Clift  8/17/91
//

#ifndef __POPUP_HPP
#define __POPUP_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __MENU_HPP
#include "menu.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class PopupMenu : public Menu {
public:
    // getSub constructors and methods first load a dummy top-level menu,
    // then use handle to get a submenu at the given position.
    PopupMenu(LPCSTR lpRes, int nPos)
        : Menu(LoadMenu(NULL, lpRes), nPos) {}
    PopupMenu(HINSTANCE hInst, LPCSTR lpName, int nPos)
        : Menu(LoadMenu(hInst, lpName), nPos) {}

    HMENU getSub(LPCSTR lpRes, int nPos)
        { return Menu::getSub(LoadMenu(NULL, lpRes), nPos); }
    HMENU getSub(HINSTANCE hInst, LPCSTR lpName, int nPos)
        { return Menu::getSub(LoadMenu(hInst, lpName), nPos); }

    // create overrides Menu class by calling CreatePopupMenu
    HMENU   create(void) { return doCreate(CreatePopupMenu()); }

    // Windows convenience methods
    BOOL    track(int x, int y, HWND hw)
        { return TrackPopupMenu(hmenu(), 0, x, y, 0, hw, NULL); }
    BOOL    track(POINT p, HWND hw)
        { return TrackPopupMenu(hmenu(), 0, p.x, p.y, 0, hw, NULL); }

};  // PopupMenu

#endif // __POPUP_HPP
