//
// PUSHBUTT.HPP Interface for PushButton, derived from Window.
//
// Created:     Bruce Clift  8/26/91
//

#ifndef __PUSHBUTT_HPP
#define __PUSHBUTT_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __CONTROL_HPP
#include "control.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class PushButton : public Control {
public:
    // Constructors
    PushButton() : Control() {}
    PushButton(HWND hd, int id) : Control(hd, id) {}

    // Creation method alterations
    LPCSTR getClassName(void) { return "button"; }
    long addStyle(long l) { return (BS_PUSHBUTTON | Control::addStyle(l)); }

    // Message functions
    void    state(BOOL bState) { SendMessage(hwnd(), BM_SETSTATE, bState, 0L); }
    BOOL    state(void) { return SendMessage(hwnd(), BM_GETSTATE, 0, 0L); }
    void    setDef(void)
        { if (_hDlg) SendMessage(_hDlg, DM_SETDEFID, _wID, 0L); }

};

#endif // __PUSHBUTT_HPP
