//
// RADIOBUT.HPP Interface for RadioButton, derived from Window.
//
// Created:     Bruce Clift  8/26/91
//

#ifndef __RADIOBUT_HPP
#define __RADIOBUT_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __CONTROL_HPP
#include "control.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class RadioButton : public Control {
public:
    // Constructors and destructors
    RadioButton() : Control() {}
    RadioButton(HWND hd, int id) : Control(hd, id) {}

    // Creation method alterations
    LPCSTR getClassName(void) { return "button"; }
    long addStyle(long l) { return (BS_RADIOBUTTON | Control::addStyle(l)); }

    // Message functions
    void    check(WORD wCheck) { SendMessage(hwnd(), BM_SETCHECK, wCheck, 0L); }
    WORD    check(void) { return SendMessage(hwnd(), BM_GETCHECK, 0, 0L); }
    void    state(BOOL bState) { SendMessage(hwnd(), BM_SETSTATE, bState, 0L); }
    BOOL    state(void) { return SendMessage(hwnd(), BM_GETSTATE, 0, 0L); }

};

#endif // __RADIOBUT_HPP
