//
// REGWINCL.HPP The RegWinCls C++ class handles window class registration.
//
// Created:     Bruce Clift  6/24/91
//

#ifndef __REGWINCL_HPP
#define __REGWINCL_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __HANDLER_HPP
#include "handler.hpp"
#endif


/////////////////////////////
// DEFAULT INITIALIZATIONS //
/////////////////////////////

#define DEF_CLSSTYLE    0
#define DEF_MNUNAME     NULL
#define DEF_HICON       0xffff
#define DEF_HCURSOR     0xffff
#define DEF_HBRBACK     GetStockObject(WHITE_BRUSH)
#define DEF_CLSEXTRA    0
#define DEF_WNDEXTRA    0


/////////////////////
// CLASS INTERFACE //
/////////////////////

class RegWinCls : public WNDCLASS {
protected:
    Handler *_pNewHandler;  // Pointer to new Handler object

public:
    // Constructors and destructors
    RegWinCls(LPCSTR cn, HINSTANCE hInst, Handler *pHand,
        UINT    s   = DEF_CLSSTYLE,
        LPCSTR  mn  = DEF_MNUNAME,
        HICON   hi  = DEF_HICON,
        HCURSOR hc  = DEF_HCURSOR,
        HBRUSH  hbr = DEF_HBRBACK,
        int     ce  = DEF_CLSEXTRA,
        int     we  = DEF_WNDEXTRA
    );
    RegWinCls(HWND hwnd);   // Base window class on existing window
    RegWinCls(LPCSTR cn, HINSTANCE hInst=NULL); // or existing class
    ~RegWinCls();           // Destructor frees strings

    // Data member access (just the offset portion of strings is returned)
    void    className(LPCSTR lpStr);
    PSTR    className(void) { return ((PSTR) LOWORD((LONG) lpszClassName)); }
    void    menuName(LPCSTR lpStr);
    PSTR    menuName(void) { return ((PSTR) LOWORD((LONG) lpszMenuName)); }
    void    pNewHandler(Handler *pHand);

    // Register window class method
    BOOL    regClass(void);
    BOOL    unRegClass(void)
        { return UnregisterClass(className(), hInstance); }

};  // RegWinCls

#endif // __REGWINCL_HPP
