//
// RESOURCE.HPP Interface for user-defined resources.
//
// Created:     Bruce Clift  8/21/91
//

#ifndef __RESOURCE_HPP
#define __RESOURCE_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Resource {
private:
    HGLOBAL _handle;        // User-defined resource handle

public:
    // Default constructor clears handle
    Resource();

    // Load constructor and method load a user-defined resource
    Resource(HINSTANCE hInst, LPCSTR lpName, LPCSTR lpType)
        { load(hInst, lpName, lpType); }
    HGLOBAL load(HINSTANCE hInst, LPCSTR lpName, LPCSTR lpType);

    // Destructor and destroy method free a loaded resource
    ~Resource() { destroy(); }
    BOOL destroy(void);

    // Data member access
    HGLOBAL handle(void) { return (_handle); }
    HGLOBAL handle(HGLOBAL h) { return (_handle = h); }

    // Operator methods
    BOOL operator! (void) { return (_handle == NULL); }
    operator HGLOBAL (void) { return (_handle); }

    // User-defined resource management
    LPSTR   lock(void)      { return LockResource(_handle); }
    BOOL    unlock(void)    { return UnlockResource(_handle); }

};  // Resource

#endif // __RESOURCE_HPP
