//
// RIBBON.HPP   Interface for Ribbon modeless dialog box class.
//
// Created:     Bruce Clift  11/9/91
//

#ifndef __RIBBON_HPP
#define __RIBBON_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __MODELESS_HPP
#include "modeless.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class Ribbon : public Modeless {
public:
    // Default constructor
    Ribbon();

#pragma warn -hid
    // Creation method
    virtual HWND create(HWND hwParent, HINSTANCE hInst = NULL);
#pragma warn .hid

    // Override Modeless method and DON'T automatically
    // show Ribbon dialog boxes.
    BOOL createVisible(void);

    // Allow derived classes to set template name
    virtual char *getTemplate(void);

    // Special ribbon callback methods
    void regDefMsgs(Handler *pHand);
    LRESULT wmEnable(UINT, WPARAM, LPARAM);
    LRESULT wmPaint(UINT, WPARAM, LPARAM);
    LRESULT idOkCancel(UINT, WPARAM, LPARAM);

};

#endif //__RIBBON_HPP
