//
// SCROLLBA.HPP Interface for ScrollBar, derived from Window.
//
// Created:     Bruce Clift  8/26/91
//

#ifndef __SCROLLBA_HPP
#define __SCROLLBA_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __CONTROL_HPP
#include "control.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class ScrollBar : public Control {
public:
    // Constructors and destructors
    ScrollBar() : Control() {}
    ScrollBar(HWND hd, int id) : Control(hd, id) {}

    // Creation method alterations
    LPCSTR getClassName(void) { return "scrollbar"; }

    // Windows convenience functions
    int     getPos(void)
        { return GetScrollPos(hwnd(), SB_CTL); }
    int     setPos(int nPos, BOOL bRedraw)
        { return SetScrollPos(hwnd(), SB_CTL, nPos, bRedraw); }
    void    getRange(LPINT lpMinPos, LPINT lpMaxPos)
        { GetScrollRange(hwnd(), SB_CTL, lpMinPos, lpMaxPos); }
    void    setRange(int nMinPos, int nMaxPos, BOOL bRedraw)
        { SetScrollRange(hwnd(), SB_CTL, nMinPos, nMaxPos, bRedraw); }
    void    show(BOOL bShow) { ShowScrollBar(hwnd(), SB_CTL, bShow); }

};

#endif // __SCROLLBA_HPP
