//
// STRINGRE.HPP Interface for StringResource class.
//
// Created:     Bruce Clift  8/22/91
//

#ifndef __STRINGRE_HPP
#define __STRINGRE_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class StringResource {
private:
    PSTR    pString;        // Buffer to hold string
    int     nMaxLen;        // Maximum length of string

public:
    // Constructors and destructors
    StringResource(int nMax = 0);
    ~StringResource(void) { destroy(); }

    // Data member accessing
    int     load(HINSTANCE hInst, UINT wID)
        { return LoadString(hInst, wID, pString, nMaxLen); }
    int     maxLength(int nMax);
    int     maxLength(void) { return nMaxLen; }
    int     length(void)    { return (pString ? lstrlen(pString) : 0); }
    void    destroy(void)   { maxLength(0); }
    int     getInstanceData(HANDLE hPrevInst)
        { return GetInstanceData(hPrevInst, (BYTE*)pString, nMaxLen); }

    // Operator methods
    BOOL operator ! (void) { return (!pString || !*pString); }
    operator char * (void) { return (pString); }

};  // StringResource

#endif // __STRINGRE_HPP
