//
// SUBHAND.HPP  Interface for subclassed message handlers.
//
// Created:     Bruce Clift  9/10/91
//

#ifndef __SUBHAND_HPP
#define __SUBHAND_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __HANDLER_HPP
#include "handler.hpp"
#endif

class Window;


/////////////////////
// CLASS INTERFACE //
/////////////////////

class SubHandler : public Handler {
private:
    HWND _hwSub;                    // Subclassed window handle

public:
    // Default constructor builds callback method lists
    SubHandler(PCB pMsgList=NULL, PCB pCmdList=NULL);

    // Destructor restores original win proc for subclassed window
    ~SubHandler();

    // Subclass a window (i.e. change its window procedure)
    void subClass(Window *pWin, HINSTANCE hInst);

    // Data member access
    HWND hwSub(HWND hw) { return (_hwSub = hw); }
    HWND hwSub(void)    { return _hwSub; }

};  // SubHandler

#endif // __SUBHAND_HPP
