//
// WFDEFS.HPP   Definitions required for all headers.
//
// Created:     Bruce Clift  11/26/91
//              Greg Voss    5/10/93   adapt for MSC 7.0
//                                     define conditional macros:
//                                     BCC(x), MSC(x)
//

#ifndef __WFDEFS_HPP
#define __WFDEFS_HPP
               
////////////////////////////////////////////////////////////
// define BCC(x) and MSC(x)                  
//
// These macros allow convenient tests for conditional 
// inclusion of code depending on whether Borland C++ 
// or Microsoft C/C++ is being used to compile source.
////////////////////////////////////////////////////////////

#ifdef __BORLANDC__     // Compiling for Borland C++
#   define BCC(x)  x    // BCC(x) expands to its argument
#   define MSC(x)       // expand to empty string
#else
#   if( defined(_MSC_VER) && _MSC_VER==700 )
#   pragma message( "wfdefs.hpp: Compiling for Microsoft C++" )
#   define BCC(x)       // expand to empty string
#   define MSC(x)  x    // MSC(x) expands to its argument
#   endif   // _MSC_VER
#endif      // __BORLANDC__
              

//////////////////////////
// COMPILER DIFFERENCES //
//////////////////////////

#if defined(__BORLANDC__)
#   define EXPORT _export
#else
#   define EXPORT
#endif


///////////////////////////////////////////
// WINDOWS 3.0 COMPATIBILITY DEFINITIONS //
///////////////////////////////////////////

#if !defined(WINVER)
#   define WINVER 0x0300
#endif

#if (WINVER < 0x030a)   // Windows 3.0

#   define UINT         WORD
#   define WPARAM       WORD
#   define LPARAM       LONG
#   define LRESULT      LONG

    // Typedef Windows window procedure like Windows 3.1 does
    typedef LRESULT (FAR PASCAL *WNDPROC) (HWND, UINT, WPARAM, LPARAM);

    // Treat constant far string pointers as regular far string pointers
    typedef LPSTR LPCSTR;

    // Define handles new to Windows 3.1 as normal handles in 3.0
#   define HACCEL       HANDLE
#   define HDRVR        HANDLE
#   define HDWP         HANDLE
#   define HFILE        HANDLE
#   define HGLOBAL      HANDLE
#   define HGDIOBJ      HANDLE
#   define HINSTANCE    HANDLE
#   define HLOCAL       HANDLE
#   define HMETAFILE    HANDLE
#   define HRSRC        HANDLE
#   define HTASK        HANDLE

// Use special symbols for parameter changes made in Windows 3.1
typedef RECT  FAR * LPCRECT;
typedef POINT FAR * LPCPOINT;
typedef int   FAR * LPCINT;
typedef LPSTR       HPVOID;
typedef LPSTR       HPCVOID;

#else // Windows 3.1

typedef const RECT  FAR *   LPCRECT;
typedef const POINT FAR *   LPCPOINT;
typedef const int   FAR *   LPCINT;
typedef       void _huge *  HPVOID;
typedef const void _huge *  HPCVOID;

#endif


//////////////////////////////
// OTHER USEFUL DEFINITIONS //
//////////////////////////////

#endif // __WFDEFS_HPP
