//
// WINCREAT.HPP Interface for WinCreate class, to handle window creation.
//
// Created:     Bruce Clift  7/20/91
//

#ifndef __WINCREAT_HPP
#define __WINCREAT_HPP

#ifndef __WFDEFS_HPP
#include "wfdefs.hpp"
#endif

#ifndef __WINDEF_H
#include "windef.h"
#endif


/////////////////////
// CLASS INTERFACE //
/////////////////////

class WinCreate : public CREATESTRUCT {
public:
    // Main constructor lets user set items as desired
    WinCreate(
        LPCSTR      cls         = DEF_CLASS,
        LPCSTR      name        = DEF_NAME,
        HINSTANCE   hInst       = DEF_HINST,
        LONG        lStyle      = DEF_NOSTYLE,
        HMENU       hMnu        = DEF_HMENU,
        HWND        hwParent    = DEF_HWPARENT,
        int         xx          = DEF_X,
        int         yy          = DEF_Y,
        int         cxx         = DEF_CX,
        int         cyy         = DEF_CY,
        LPSTR       lpParam     = DEF_LPPARAM,
        long        lExStyle    = DEF_EXSTYLE
    );
    WinCreate(HWND hwnd);   // Get creation info from Windows
    ~WinCreate();           // Destructor frees string memory

    // Method to create the window
    HWND create(void)
        { return CreateWindowEx(dwExStyle, className(), winName(), style,
            x, y, cx, cy, hwndParent, hMenu, hInstance, lpCreateParams); }

    // Data member access (return offset only -- DS may be movable)
    void className(LPCSTR lpStr);
    PSTR className(void) { return ((PSTR) LOWORD((LONG) lpszClass)); }
    void winName(LPCSTR lpStr);
    PSTR winName(void) { return ((PSTR) LOWORD((LONG) lpszName)); }

};  // WinCreate

#endif // __WINCREAT_HPP
