//
// CURSOR.CPP   Methods for Cursor class.
//
// Created:     Bruce Clift  11/25/91
//

#include <windows.h>

#include "cursor.hpp"


//
// Default constructor clears instance variables.
//
Cursor::Cursor() : _hcursor(NULL), bCreated(FALSE)
{}

//
// Load method loads a cursor resource.
//
HCURSOR
Cursor::load(HINSTANCE hInst, LPCSTR lpName)
{
    bCreated = FALSE;
    return (_hcursor = LoadCursor(hInst, lpName));
}

//
// The create method manually creates a cursor.
//
HCURSOR
Cursor::create(HINSTANCE hInst, int x, int y, int nWidth, int nHeight,
        LPCSTR lpANDbits, LPCSTR lpXORbits)
{
    bCreated = TRUE;
    return (_hcursor = CreateCursor(hInst, x, y, nWidth, nHeight,
        lpANDbits, lpXORbits));
}

//
// The destroy method destroys cursors that were created.
//
BOOL
Cursor::destroy(void)
{
    if (!_hcursor)
        return FALSE;
    if (bCreated)
        DestroyCursor(_hcursor);
    _hcursor = NULL;
    bCreated = FALSE;
    return TRUE;
}
