//
// DEVCONTE.CPP Implementation of DevContext class methods.
//
// Created:     Bruce Clift  9/21/91
//

#include <windows.h>
#pragma hdrstop
#include <string.h>

#include "devconte.hpp"


//////////////////////////////////////////
// DEVICE CONTEXT METHOD IMPLEMENTATION //
//////////////////////////////////////////

//
// doPrinter creates a device or info context for the current printer.
//
HDC
DevContext::doPrinter(BOOL bInfo)
{
    // Flag that this printer context is being created, not gotten
    _hw = NULL;

    // Get printer profile string from WININI file
    char szPrinter[80];
    GetProfileString("windows", "device", "", szPrinter, 80);

    // Break profile string up into parts, using comma as token
    char *szDevice, *szDriver, *szOutput;
    if ((szDevice = strtok(szPrinter, ",")) &&
        (szDriver = strtok(NULL,      ",")) &&
        (szOutput = strtok(NULL,      ",")) )
    {
        // If successful, create information or device context
        if (bInfo)
                return (_hdc=CreateIC(szDriver, szDevice, szOutput, NULL));
        else    return (_hdc=CreateDC(szDriver, szDevice, szOutput, NULL));
    }
    return (_hdc = NULL);       // Unable to parse profile string
}
