//
// FONT.CPP     Methods for Font class.
//
// Created:     Bruce Clift     11/25/91
//              Greg Voss       5/10/93   adapt for MSC 7.0
//

#include <windows.h>
#include <memory.h>

#include "font.hpp"


//
// Default constructor clears instance variables and LOGFONT struct.
//
Font::Font() : _hfont(NULL), bStock(FALSE)
{
    memset((LOGFONT *) this, 0, sizeof(LOGFONT));
}

//
// The no-parameter create expects the caller to fill LOGFONT fields.
//
HFONT
Font::create(void)
{
    bStock = FALSE;
    return (_hfont = CreateFontIndirect(this));
}

//
// Get stock method gets a stock font.
//
HFONT
Font::getStock(int nIndex)
{
    bStock = TRUE;
    _hfont = GetStockObject(nIndex);
    get();
    return _hfont;
}

//
// The destroy method destroys fonts that were created.
//
BOOL
Font::destroy(void)
{
    if (!_hfont)
        return FALSE;
    if (!bStock)
        DeleteObject(_hfont);
    _hfont = NULL;
    bStock = FALSE;
    return TRUE;
}
