//
// HNDUNREG.CPP Routines to unregister messages (not usually needed).
//
// Created:     Bruce Clift  11/25/91
//

#include <windows.h>
#pragma hdrstop

#include "handler.hpp"


//
// unRegMsgCb and unRegCmdCb are used to remove a callback method from the
// List class objects' list.  Since the values stored are local heap pointers,
// they must first be freed before being removed from the list.
//
BOOL
Handler::unRegMsgCb(WORD wMsg)
{
    if (!pMsgs) return FALSE;

    // Free the old callback method address buffer
    CBPROC *pCB = (CBPROC *) pMsgs->item(wMsg);
    if (pCB != NULL) LocalFree((HLOCAL) pCB);
    return pMsgs->remove(wMsg);
}

BOOL
Handler::unRegCmdCb(WORD wId)
{
    if (!pCmds) return FALSE;

    // Free the old callback method address buffer
    CBPROC *pCB = (CBPROC *) pCmds->item(wId);
    if (pCB != NULL) LocalFree((HLOCAL) pCB);
    return pCmds->remove(wId);
}
