//
// ICON.CPP     Methods for Icon class.
//
// Created:     Bruce Clift  11/25/91
//

#include <windows.h>

#include "icon.hpp"


//
// Default constructor clears instance variables.
//
Icon::Icon() : _hicon(NULL), bCreated(FALSE)
{}

//
// Load method loads a icon resource.
//
HICON
Icon::load(HINSTANCE hInst, LPCSTR lpName)
{
    bCreated = FALSE;
    return (_hicon = LoadIcon(hInst, lpName));
}

//
// The destroy method destroys icons that were created.
//
BOOL
Icon::destroy(void)
{
    if (!_hicon)
        return FALSE;
    if (bCreated)
        DestroyIcon(_hicon);
    _hicon = NULL;
    bCreated = FALSE;
    return TRUE;
}
