//
// MENU.CPP     Methods for Menu class.
//
// Created:     Bruce Clift  11/25/91
//

#include <windows.h>

#include "menu.hpp"


//
// Default constructor clears instance variables.
//
Menu::Menu() : _hmenu(NULL), _hw(NULL), bCreated(FALSE)
{}

//
// Load method loads a menu resource.
//
HMENU
Menu::load(HINSTANCE hInst, LPCSTR lpName)
{
    bCreated = FALSE;
    _hw = NULL;
    return (_hmenu = LoadMenu(hInst, lpName));
}

//
// Method to do the work for create (and derived class creates).
//
HMENU
Menu::doCreate(HMENU hm)
{
    bCreated = TRUE;
    _hw = NULL;
    return (_hmenu = hm);
}

//
// The destroy method destroys menus that were created.
//
BOOL
Menu::destroy(void)
{
    if (!_hmenu)
        return FALSE;
    if (bCreated)
        DestroyMenu(_hmenu);
    _hmenu = NULL;
    bCreated = FALSE;
    return TRUE;
}
