//
// MSGLOOP3.CPP Message loop number 3 for Message class.
//
// Created:     Bruce Clift  8/14/91
//

#include <windows.h>
#pragma hdrstop

#include "message.hpp"
#include "window.hpp"


//
// The loop method operates Windows message loop with an accelerator table.
//  INPUT: pMain is a pointer to the main window. 
//  RETURNS: the WPARAM parameter of the WM_QUIT message.
//
WPARAM
Message::loop(Window *pMain)
{
    while (get()) {
        if (!accelerator(pMain->hwnd(), pMain->getAccel())) {
            translate();
            dispatch();
        }
    }
    return wParam;
}

