//
// MSGLOOP4.CPP Message loop number 4 for Message class.
//
// Created:     Bruce Clift  8/14/91
//

#include <windows.h>
#pragma hdrstop

#include "message.hpp"
#include "window.hpp"
#include "modeless.hpp"


//
// The loop method operates a simple Windows message loop.
//  INPUT: pMain is a pointer to the main window.  pMdls is the pointer to a
// Modeless dialog box object.
//  RETURNS: the WPARAM parameter of the WM_QUIT message.
//
WPARAM
Message::loop(Window *pMain, Modeless *pMdls)
{
    while (get()) {
        if (!accelerator(pMain->hwnd(), pMain->getAccel()) &&
            !isDialog(pMdls->hwnd()) ) {
            translate();
            dispatch();
        }
    }
    return wParam;
}

