//
// MSGLOOP7.CPP Message loop number 7 for Message class.
//
// Created:     Bruce Clift  8/14/91
//

#include <windows.h>
#pragma hdrstop

#include "message.hpp"
#include "window.hpp"


//
// The loop method operates a Windows message loop for an application which
// includes the Multiple Document Interface.
//  INPUT: hwClient is the handle to the MDI client window. pMain is a pointer
// to the main window. 
//  RETURNS: the WPARAM parameter of the WM_QUIT message.
//
WPARAM
Message::loop(HWND hwClient, Window *pMain)
{
    while (get()) {
        if (!mdiSysAccel(hwClient) &&
            !accelerator(pMain->hwnd(), pMain->getAccel())) {
            translate();
            dispatch();
        }
    }
    return wParam;
}
