//
// PALETTE.CPP  Methods for Palette class.
//
// Created:     Bruce Clift     11/25/91
//              Greg Voss       5/10/93   adapt for MSC 7.0
//

#include <windows.h>
#include <memory.h>

#include "palette.hpp"


//
// Default constructor clears the handle and LOGPALETTE structure.
//
Palette::Palette() : _hpalette(NULL), bStock(FALSE)
{
    memset((LOGPALETTE *) this, 0, sizeof(LOGPALETTE));
}

//
// Get stock method gets the stock default palette.
//
HPALETTE
Palette::getStock(void)
{
    bStock = TRUE;
    _hpalette = GetStockObject(DEFAULT_PALETTE);
    get();
    return _hpalette;
}

//
// The destroy method destroys palettes that were created.
//
void
Palette::destroy(void)
{
    if (!_hpalette)
        return;
    if (!bStock)
        DeleteObject(_hpalette);
    _hpalette = NULL;
    bStock = FALSE;
}
