//
// PEN.CPP      Methods for Pen class.
//
// Created:     Bruce Clift  11/25/91
//              Greg Voss    5/10/93   adapt for MSC 7.0
//

#include <windows.h>
#include <memory.h>

#include "pen.hpp"


//
// Default constructor clears the handle and LOGPEN structure.
//
Pen::Pen() : _hpen(NULL), bStock(FALSE)
{
    memset((LOGPEN *) this, 0, sizeof(LOGPEN));
}

//
// Get stock method gets a stock pen.
//
HPEN
Pen::getStock(int nIndex)
{
    bStock = TRUE;
    _hpen = GetStockObject(nIndex);
    get();
    return _hpen;
}

//
// The destroy method destroys pens that were created.
//
BOOL
Pen::destroy(void)
{
    if (!_hpen)
        return FALSE;
    if (!bStock)
        DeleteObject(_hpen);
    _hpen = NULL;
    bStock = FALSE;
    return TRUE;
}
