//
// RESOURCE.CPP Methods for user-defined resource class.
//
// Created:     Bruce Clift  11/25/91
//

#include <windows.h>

#include "resource.hpp"


//
// Default constructor clears handle.
//
Resource::Resource() : _handle(NULL)
{}

//
// Load method loads a user-defined resource.
//
HGLOBAL
Resource::load(HINSTANCE hInst, LPCSTR lpName, LPCSTR lpType)
{
    return (_handle = LoadResource(hInst,
        FindResource(hInst, lpName, lpType)));
}

//
// destroy method frees a loaded resource.
//
BOOL
Resource::destroy(void)
{
    if (!_handle)
        return FALSE;
    FreeResource(_handle);
    _handle = NULL;
    return TRUE;
}
