//
// RWCWIN.CPP   Implementation of RegWinCls constructor from existing window.
//
// Created:     Bruce Clift  10/12/91
//

#include <windows.h>
#pragma hdrstop

#include "regwincl.hpp"


//
// Construct window class registration info based on existing window.
//
RegWinCls::RegWinCls(HWND hwnd)
{
    // Alloc buffer for class name and copy it in
    PSTR buf = (PSTR) LocalAlloc(LPTR, 40);
    GetClassName(hwnd, buf, 40);
    lpszClassName = NULL;       // Flag that there is no string to free yet
    className(buf);             // Allocate space and copy in string
    LocalFree((HLOCAL) buf);

    // Get instance and other class info
    hInstance = GetClassWord(hwnd, GCW_HMODULE);
    GetClassInfo(hInstance, lpszClassName, this);
    // NOTE: although the menu name is not supposed to be set by GetClassInfo,
    // the field's value does sometimes change!  Must clear AFTER this call!!!
    lpszMenuName = NULL;

    // Clear the Handler object pointer, to avoid possible confusion
    _pNewHandler = NULL;
}
