//
// WINCRE1.CPP  Implementation of WinCreate constructor from existing window.
//
// Created:     Bruce Clift  10/20/91
//

#include <windows.h>
#pragma hdrstop

#include "wincreat.hpp"


//
// Construct window creation class based on existing window.
//
WinCreate::WinCreate(HWND hwnd)
{
    // Flag that there are no strings to free yet
    lpszClass = lpszName = NULL;

    // Get class name and window text
    PSTR buf = (PSTR) LocalAlloc(LPTR, 40);
    GetClassName(hwnd, buf, 40);
    className(buf);
    GetWindowText(hwnd, buf, 40);
    winName(buf);
    LocalFree((HLOCAL) buf);

    RECT r;                                 // Get window size/position
    GetWindowRect(hwnd, &r);
    x = r.left;
    y = r.top;
    cx = r.right - r.left;
    cy = r.bottom - r.top;

    style = GetWindowLong(hwnd, GWL_STYLE); // Get other creation items
    dwExStyle = GetWindowLong(hwnd, GWL_EXSTYLE);
    hInstance = GetWindowWord(hwnd, GWW_HINSTANCE);
    if ((style & WS_CHILD) == WS_CHILD)
        hMenu = GetWindowWord(hwnd, GWW_ID);
    hwndParent = GetWindowWord(hwnd, GWW_HWNDPARENT);
}
